//
// This file was generated by the JavaTM Architecture for XML Binding(JAXB) Reference Implementation, v2.3.2 
// See <a href="https://javaee.github.io/jaxb-v2/">https://javaee.github.io/jaxb-v2/</a> 
// Any modifications to this file will be lost upon recompilation of the source schema. 
// Generated on: 2020.02.07 at 09:07:12 PM CET 
//


package org.tdwg.abcd2;

import java.util.ArrayList;
import java.util.List;
import jakarta.xml.bind.annotation.XmlAccessType;
import jakarta.xml.bind.annotation.XmlAccessorType;
import jakarta.xml.bind.annotation.XmlAttribute;
import jakarta.xml.bind.annotation.XmlElement;
import jakarta.xml.bind.annotation.XmlSchemaType;
import jakarta.xml.bind.annotation.XmlType;
import jakarta.xml.bind.annotation.XmlValue;
import jakarta.xml.bind.annotation.adapters.NormalizedStringAdapter;
import jakarta.xml.bind.annotation.adapters.XmlJavaTypeAdapter;


/**
 * An atomized scientific name under the International Code of Botanical Nomenclature or the International Code of Nomenclature for Cultivated Plants
 * 
 * <p>Java class for NameBotanical complex type.
 * 
 * <p>The following schema fragment specifies the expected content contained within this class.
 * 
 * <pre>
 * &lt;complexType name="NameBotanical"&gt;
 *   &lt;complexContent&gt;
 *     &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType"&gt;
 *       &lt;sequence&gt;
 *         &lt;element name="GenusOrMonomial" type="{http://www.tdwg.org/schemas/abcd/3.0}Monomial" minOccurs="0"/&gt;
 *         &lt;element name="FirstEpithet" type="{http://www.tdwg.org/schemas/abcd/3.0}Epithet" minOccurs="0"/&gt;
 *         &lt;element name="InfraspecificEpithet" type="{http://www.tdwg.org/schemas/abcd/3.0}Epithet" minOccurs="0"/&gt;
 *         &lt;element name="Rank" type="{http://www.tdwg.org/schemas/abcd/3.0}RankAbbreviation" minOccurs="0"/&gt;
 *         &lt;element name="HybridFlag" minOccurs="0"&gt;
 *           &lt;complexType&gt;
 *             &lt;simpleContent&gt;
 *               &lt;extension base="&lt;http://www.w3.org/2001/XMLSchema&gt;string"&gt;
 *                 &lt;attribute name="insertionpoint"&gt;
 *                   &lt;simpleType&gt;
 *                     &lt;restriction base="{http://www.w3.org/2001/XMLSchema}int"&gt;
 *                       &lt;enumeration value="1"/&gt;
 *                       &lt;enumeration value="2"/&gt;
 *                       &lt;enumeration value="3"/&gt;
 *                     &lt;/restriction&gt;
 *                   &lt;/simpleType&gt;
 *                 &lt;/attribute&gt;
 *               &lt;/extension&gt;
 *             &lt;/simpleContent&gt;
 *           &lt;/complexType&gt;
 *         &lt;/element&gt;
 *         &lt;element name="AuthorTeamParenthesis" type="{http://www.tdwg.org/schemas/abcd/3.0}String" minOccurs="0"/&gt;
 *         &lt;element name="AuthorTeam" type="{http://www.tdwg.org/schemas/abcd/3.0}String" minOccurs="0"/&gt;
 *         &lt;element name="CultivarGroupName" type="{http://www.tdwg.org/schemas/abcd/3.0}String" minOccurs="0"/&gt;
 *         &lt;element name="CultivarName" type="{http://www.tdwg.org/schemas/abcd/3.0}String" minOccurs="0"/&gt;
 *         &lt;element name="TradeDesignationNames" minOccurs="0"&gt;
 *           &lt;complexType&gt;
 *             &lt;complexContent&gt;
 *               &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType"&gt;
 *                 &lt;sequence&gt;
 *                   &lt;element name="TradeDesignationName" type="{http://www.tdwg.org/schemas/abcd/3.0}String" maxOccurs="unbounded"/&gt;
 *                 &lt;/sequence&gt;
 *               &lt;/restriction&gt;
 *             &lt;/complexContent&gt;
 *           &lt;/complexType&gt;
 *         &lt;/element&gt;
 *       &lt;/sequence&gt;
 *     &lt;/restriction&gt;
 *   &lt;/complexContent&gt;
 * &lt;/complexType&gt;
 * </pre>
 * 
 * 
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "NameBotanical", propOrder = {
    "genusOrMonomial",
    "firstEpithet",
    "infraspecificEpithet",
    "rank",
    "hybridFlag",
    "authorTeamParenthesis",
    "authorTeam",
    "cultivarGroupName",
    "cultivarName",
    "tradeDesignationNames"
})
public class NameBotanical {

    @XmlElement(name = "GenusOrMonomial")
    protected String genusOrMonomial;
    @XmlElement(name = "FirstEpithet")
    protected String firstEpithet;
    @XmlElement(name = "InfraspecificEpithet")
    protected String infraspecificEpithet;
    @XmlElement(name = "Rank")
    @XmlSchemaType(name = "Name")
    protected RankAbbreviation rank;
    @XmlElement(name = "HybridFlag")
    protected NameBotanical.HybridFlag hybridFlag;
    @XmlElement(name = "AuthorTeamParenthesis")
    @XmlJavaTypeAdapter(NormalizedStringAdapter.class)
    @XmlSchemaType(name = "normalizedString")
    protected String authorTeamParenthesis;
    @XmlElement(name = "AuthorTeam")
    @XmlJavaTypeAdapter(NormalizedStringAdapter.class)
    @XmlSchemaType(name = "normalizedString")
    protected String authorTeam;
    @XmlElement(name = "CultivarGroupName")
    @XmlJavaTypeAdapter(NormalizedStringAdapter.class)
    @XmlSchemaType(name = "normalizedString")
    protected String cultivarGroupName;
    @XmlElement(name = "CultivarName")
    @XmlJavaTypeAdapter(NormalizedStringAdapter.class)
    @XmlSchemaType(name = "normalizedString")
    protected String cultivarName;
    @XmlElement(name = "TradeDesignationNames")
    protected NameBotanical.TradeDesignationNames tradeDesignationNames;

    /**
     * Gets the value of the genusOrMonomial property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getGenusOrMonomial() {
        return genusOrMonomial;
    }

    /**
     * Sets the value of the genusOrMonomial property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setGenusOrMonomial(String value) {
        this.genusOrMonomial = value;
    }

    /**
     * Gets the value of the firstEpithet property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getFirstEpithet() {
        return firstEpithet;
    }

    /**
     * Sets the value of the firstEpithet property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setFirstEpithet(String value) {
        this.firstEpithet = value;
    }

    /**
     * Gets the value of the infraspecificEpithet property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getInfraspecificEpithet() {
        return infraspecificEpithet;
    }

    /**
     * Sets the value of the infraspecificEpithet property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setInfraspecificEpithet(String value) {
        this.infraspecificEpithet = value;
    }

    /**
     * Gets the value of the rank property.
     * 
     * @return
     *     possible object is
     *     {@link RankAbbreviation }
     *     
     */
    public RankAbbreviation getRank() {
        return rank;
    }

    /**
     * Sets the value of the rank property.
     * 
     * @param value
     *     allowed object is
     *     {@link RankAbbreviation }
     *     
     */
    public void setRank(RankAbbreviation value) {
        this.rank = value;
    }

    /**
     * Gets the value of the hybridFlag property.
     * 
     * @return
     *     possible object is
     *     {@link NameBotanical.HybridFlag }
     *     
     */
    public NameBotanical.HybridFlag getHybridFlag() {
        return hybridFlag;
    }

    /**
     * Sets the value of the hybridFlag property.
     * 
     * @param value
     *     allowed object is
     *     {@link NameBotanical.HybridFlag }
     *     
     */
    public void setHybridFlag(NameBotanical.HybridFlag value) {
        this.hybridFlag = value;
    }

    /**
     * Gets the value of the authorTeamParenthesis property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getAuthorTeamParenthesis() {
        return authorTeamParenthesis;
    }

    /**
     * Sets the value of the authorTeamParenthesis property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setAuthorTeamParenthesis(String value) {
        this.authorTeamParenthesis = value;
    }

    /**
     * Gets the value of the authorTeam property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getAuthorTeam() {
        return authorTeam;
    }

    /**
     * Sets the value of the authorTeam property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setAuthorTeam(String value) {
        this.authorTeam = value;
    }

    /**
     * Gets the value of the cultivarGroupName property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getCultivarGroupName() {
        return cultivarGroupName;
    }

    /**
     * Sets the value of the cultivarGroupName property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setCultivarGroupName(String value) {
        this.cultivarGroupName = value;
    }

    /**
     * Gets the value of the cultivarName property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getCultivarName() {
        return cultivarName;
    }

    /**
     * Sets the value of the cultivarName property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setCultivarName(String value) {
        this.cultivarName = value;
    }

    /**
     * Gets the value of the tradeDesignationNames property.
     * 
     * @return
     *     possible object is
     *     {@link NameBotanical.TradeDesignationNames }
     *     
     */
    public NameBotanical.TradeDesignationNames getTradeDesignationNames() {
        return tradeDesignationNames;
    }

    /**
     * Sets the value of the tradeDesignationNames property.
     * 
     * @param value
     *     allowed object is
     *     {@link NameBotanical.TradeDesignationNames }
     *     
     */
    public void setTradeDesignationNames(NameBotanical.TradeDesignationNames value) {
        this.tradeDesignationNames = value;
    }


    /**
     * <p>Java class for anonymous complex type.
     * 
     * <p>The following schema fragment specifies the expected content contained within this class.
     * 
     * <pre>
     * &lt;complexType&gt;
     *   &lt;simpleContent&gt;
     *     &lt;extension base="&lt;http://www.w3.org/2001/XMLSchema&gt;string"&gt;
     *       &lt;attribute name="insertionpoint"&gt;
     *         &lt;simpleType&gt;
     *           &lt;restriction base="{http://www.w3.org/2001/XMLSchema}int"&gt;
     *             &lt;enumeration value="1"/&gt;
     *             &lt;enumeration value="2"/&gt;
     *             &lt;enumeration value="3"/&gt;
     *           &lt;/restriction&gt;
     *         &lt;/simpleType&gt;
     *       &lt;/attribute&gt;
     *     &lt;/extension&gt;
     *   &lt;/simpleContent&gt;
     * &lt;/complexType&gt;
     * </pre>
     * 
     * 
     */
    @XmlAccessorType(XmlAccessType.FIELD)
    @XmlType(name = "", propOrder = {
        "value"
    })
    public static class HybridFlag {

        @XmlValue
        protected String value;
        @XmlAttribute(name = "insertionpoint")
        protected Integer insertionpoint;

        /**
         * Gets the value of the value property.
         * 
         * @return
         *     possible object is
         *     {@link String }
         *     
         */
        public String getValue() {
            return value;
        }

        /**
         * Sets the value of the value property.
         * 
         * @param value
         *     allowed object is
         *     {@link String }
         *     
         */
        public void setValue(String value) {
            this.value = value;
        }

        /**
         * Gets the value of the insertionpoint property.
         * 
         * @return
         *     possible object is
         *     {@link Integer }
         *     
         */
        public Integer getInsertionpoint() {
            return insertionpoint;
        }

        /**
         * Sets the value of the insertionpoint property.
         * 
         * @param value
         *     allowed object is
         *     {@link Integer }
         *     
         */
        public void setInsertionpoint(Integer value) {
            this.insertionpoint = value;
        }

    }


    /**
     * <p>Java class for anonymous complex type.
     * 
     * <p>The following schema fragment specifies the expected content contained within this class.
     * 
     * <pre>
     * &lt;complexType&gt;
     *   &lt;complexContent&gt;
     *     &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType"&gt;
     *       &lt;sequence&gt;
     *         &lt;element name="TradeDesignationName" type="{http://www.tdwg.org/schemas/abcd/3.0}String" maxOccurs="unbounded"/&gt;
     *       &lt;/sequence&gt;
     *     &lt;/restriction&gt;
     *   &lt;/complexContent&gt;
     * &lt;/complexType&gt;
     * </pre>
     * 
     * 
     */
    @XmlAccessorType(XmlAccessType.FIELD)
    @XmlType(name = "", propOrder = {
        "tradeDesignationName"
    })
    public static class TradeDesignationNames {

        @XmlElement(name = "TradeDesignationName", required = true)
        @XmlJavaTypeAdapter(NormalizedStringAdapter.class)
        @XmlSchemaType(name = "normalizedString")
        protected List<String> tradeDesignationName;

        /**
         * Gets the value of the tradeDesignationName property.
         * 
         * <p>
         * This accessor method returns a reference to the live list,
         * not a snapshot. Therefore any modification you make to the
         * returned list will be present inside the JAXB object.
         * This is why there is not a <CODE>set</CODE> method for the tradeDesignationName property.
         * 
         * <p>
         * For example, to add a new item, do as follows:
         * <pre>
         *    getTradeDesignationName().add(newItem);
         * </pre>
         * 
         * 
         * <p>
         * Objects of the following type(s) are allowed in the list
         * {@link String }
         * 
         * 
         */
        public List<String> getTradeDesignationName() {
            if (tradeDesignationName == null) {
                tradeDesignationName = new ArrayList<String>();
            }
            return this.tradeDesignationName;
        }

    }

}
